#include "Controller.h"

#include "Command.h"

#if 1 // FEAST modify 20160128
extern int g_curStep;
#endif // FEAST modify 20160128 end

using namespace kvs::visclient;

void StartDetailedAnalysisButton::pressed( void )
{
    setButtonColor( ::Red );
    command->startDetailedAnalysis();
}

void StartAbstractAnalysisButton::pressed( void )
{
    setButtonColor( ::Red );
    command->startAbstractAnalysis();
}

void ShowHideButton::pressed( void )
{
    command->changeShowHide();
}

void StopButton::pressed( void )
{
    if ( g_curStep >= 0 )
    {
        //command->isUnderAnimation ? setButtonColor( ::Gray ) : setButtonColor( ::Red );
#if 0
        // ボタンの色を反転
        command->isUnderAnimation ? setButtonColor( ::Red ) : setButtonColor( ::Gray );
        // 内部変数を反転
        command->isUnderAnimation = !command->isUnderAnimation;
        command->isUnderCommunication = !command->isUnderCommunication;
#else
        // ボタンの色を反転
        command->isUnderCommunication ? setButtonColor( ::Red ) : setButtonColor( ::Gray );
        // 内部変数を反転
        command->isUnderCommunication = !command->isUnderCommunication;
#endif
    }
}

void LastStepCheckBox::stateChanged( void )
{

    if( this->state() )
    {
        command->timeSlider->setValue( command->param.maxServerTimeStep );
//      command->param.timeStep = static_cast<size_t>( command->param.maxServerTimeStep );
    }
}


void TimeStepSlider::sliderMoved( void )
{
    std::string cap = "Time step    :    ";
    std::stringstream cap_time;
    cap_time << cap << static_cast<int>( this->value() );
    this->setCaption( cap_time.str() );
    // FEAST modify 20160128
//  g_curStep = command->param.timeStep;
}

void TimeStepSlider::sliderReleased( void )
{
    if( !command->lastStepCheckBox->state() )
    {
        command->param.timeStep = static_cast<size_t>( this->value() );
    }
}

void TimeSegmentMinSlider::sliderMoved( void )
{
    command->param.minTimeStep = static_cast<int>( this->value() );
    if ( command->maxTimeSlider->value() < this->value() + 1.0f )
    {
        if ( this->value() + 1.0f > command->maxTimeSlider->maxValue() )
        {
            command->maxTimeSlider->setValue( command->maxTimeSlider->maxValue() );
        }
        else
        {
            command->maxTimeSlider->setValue( this->value() + 1.0f );
        }
    }
}

void TimeSegmentMaxSlider::sliderMoved( void )
{
    command->param.maxTimeStep = static_cast<int>( this->value() );
    if ( command->minTimeSlider->value() > this->value() - 1.0f )
    {
        if ( this->value() - 1.0f < command->minTimeSlider->minValue() )
        {
            command->minTimeSlider->setValue( command->minTimeSlider->minValue() );
        }
        else
        {
            command->minTimeSlider->setValue( this->value() - 1.0f );
        }
    }
}

void RandomBasedShuffleButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.shuffleType = PBVRParam::RandomBased;
    }
}

void IndexBasedSingleShuffleButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.shuffleType = PBVRParam::SingleShuffleBased;
    }
}

void IndexBasedCPUParallelShuffleButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.shuffleType = PBVRParam::CPUShuffleBased;
    }
}

void IndexBasedGPUParallelShuffleButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.shuffleType = PBVRParam::GPUShffleBased;
    }
}

void SummalizedTransferButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.detailedTransferType = PBVRParam::Summalized;
    }
}

void DividedTransferButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.detailedTransferType = PBVRParam::Divided;
    }
}

void UniformSamplingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.samplingType = PBVRParam::UniformSampling;
    }
}

void RejectionSamplingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.samplingType = PBVRParam::RejectionSampling;
    }
}

void MetropolisSamplingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.samplingType = PBVRParam::MetropolisSampling;
    }
}

void AllNodesButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.nodeType = PBVRParam::AllNodes;
    }
}

void SlaveNodesButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.nodeType = PBVRParam::SlaveNodes;
    }
}

void MisesRenderingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.renderingId = 0;
    }
}

void UXRenderingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.renderingId = 1;
    }
}

void UYRenderingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.renderingId = 2;
    }
}

void UZRenderingButton::stateChanged( void )
{
    if ( this->state() )
    {
        command->param.renderingId = 3;
    }
}

// MODIFIED START fp)m.tanaka 2013.09.01
//Controller::Controller( kvs::glut::Screen* screen, Command* command ) :
//	kvs::glut::WidgetBase(screen),
//		screen(screen),
//		command(command)
//{
Controller::Controller( kvs::glut::Screen* screen, kvs::glut::Screen* screen3, Command* command ) :
    kvs::glut::WidgetBase( screen ),
    screen( screen ),
    command( command )
{
// MODIFIED END   fp)m.tanaka 2013.09.01

//	screen->background()->setColor( kvs::RGBColor( 255, 0, 0 ));
// MODIFIED START fp)m.tanaka 2013.09.01
    //detail.reset( new StartDetailedAnalysisButton( screen, command ) );
    detail.reset( new StartDetailedAnalysisButton( screen3, command ) );
// MODIFIED END   fp)m.tanaka 2013.09.01
    detail->setButtonColor( ::Gray );
    detail->setTextColor( kvs::RGBColor( 255, 255, 255 ) );
    //detail->setButtonColor( kvs::RGBColor( 255, 0, 0 ));
// MODIFIED START fp)m.tanaka 2013.09.01
    //detail->setX( 0 );
    //detail->setY( 0 );
    detail->setX( 0 );
    detail->setY( 230 );
// MODIFIED END   fp)m.tanaka 2013.09.01
    detail->setWidth( 250 );
    detail->setMargin( 10 );
    detail->setCaption( "Detailed analysis" );
//	detail->show(); /* removed 2014.07.20 */

// MODIFIED START fp)m.tanaka 2013.09.01
    //abst.reset( new StartAbstractAnalysisButton( screen, command ) );
    abst.reset( new StartAbstractAnalysisButton( screen3, command ) );
// MODIFIED END   fp)m.tanaka 2013.09.01
    abst->setButtonColor( ::Gray );
    abst->setTextColor( kvs::RGBColor( 255, 255, 255 ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //abst->setX( 0 );
    //abst->setY( detail->y() + detail->height() );
    abst->setX( 245 );
    abst->setY( 230 );
// MODIFIED END   fp)m.tanaka 2013.09.01
    abst->setWidth( detail->width() );
    abst->setMargin( 10 );
    abst->setCaption( "Abstract analysis" );
//	abst->show(); /* removed 2014.07.20 */

    stop.reset( new StopButton( screen, command ) );
    stop->setButtonColor( ::Gray );
    stop->setTextColor( kvs::RGBColor( 255, 255, 255 ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    stop->setX( 0 );
//	stop->setY( abst->y() + abst->height() );
    stop->setY( 20 );
// MODIFIED END   fp)m.tanaka 2013.09.01
    stop->setWidth( abst->width() );
    stop->setMargin( 10 );
    stop->setCaption( "Start/Stop" );
    stop->show();

    group1.reset( new kvs::glut::RadioButtonGroup() );

    randomBased.reset( new RandomBasedShuffleButton( screen, command ) );
    randomBased->setX( 0 );
    randomBased->setY( stop->y() + stop->height() );
    randomBased->setMargin( 10 );
    randomBased->setCaption( "RandomBased" );

    indexBasedSingle.reset( new IndexBasedSingleShuffleButton( screen, command ) );
    indexBasedSingle->setX( 0 );
    indexBasedSingle->setY( randomBased->y() + 20 );
    indexBasedSingle->setMargin( 10 );
    indexBasedSingle->setCaption( "IndexBased(Single)" );

    indexBasedCPUParallel.reset( new IndexBasedCPUParallelShuffleButton( screen, command ) );
    indexBasedCPUParallel->setX( 0 );
    indexBasedCPUParallel->setY( indexBasedSingle->y() + 20 );
    indexBasedCPUParallel->setMargin( 10 );
    indexBasedCPUParallel->setCaption( "IndexBased(CPU Parallel)" );

    indexBasedGPUParallel.reset( new IndexBasedGPUParallelShuffleButton( screen, command ) );
    indexBasedGPUParallel->setX( 0 );
    indexBasedGPUParallel->setY( indexBasedCPUParallel->y() + 20 );
    indexBasedGPUParallel->setMargin( 10 );
    indexBasedGPUParallel->setCaption( "IndexBased(GPU Parallel)" );

    group1->add( randomBased.get() );
    group1->add( indexBasedSingle.get() );
    group1->add( indexBasedCPUParallel.get() );
    group1->add( indexBasedGPUParallel.get() );

// DELETE START fp)m.tanaka 2013.09.01
    //group1->show();
// DELETE END   fp)m.tanaka 2013.09.01

    group2.reset( new kvs::glut::RadioButtonGroup() );

    const kvs::RGBAColor transferColor( 0, 122, 255 );

    summalized.reset( new SummalizedTransferButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //summalized->setX( 255 );
    //summalized->setY( randomBased->y() );
    int rd_offset_x = 0;
    summalized->setX( rd_offset_x );
    summalized->setY( randomBased->y() + 20 );
// MODIFIED END   fp)m.tanaka 2013.09.01

    summalized->setMargin( 10 );
    summalized->setCaption( "Summalized Transfer" );
    summalized->setTextColor( transferColor );

    divided.reset( new DividedTransferButton( screen, command  ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //divided->setX( 255 );
    divided->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    divided->setY( summalized->y() + 20 );
    divided->setMargin( 10 );
    divided->setCaption( "Divided Transfer" );
    divided->setTextColor( transferColor );

    group2->add( summalized.get() );
    group2->add( divided.get() );
    group2->show();

    samplingGroup.reset( new kvs::glut::RadioButtonGroup() );

    const kvs::RGBAColor samplingColor( 122, 122, 122 );

    uniform.reset( new UniformSamplingButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //uniform->setX( 255 );
    uniform->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    uniform->setY( divided->y() + 20 );
    uniform->setMargin( 10 );
    uniform->setCaption( "Uniform Sampling" );
    uniform->setTextColor( samplingColor );

    rejection.reset( new RejectionSamplingButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //rejection->setX( 255 );
    rejection->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    rejection->setY( uniform->y() + 20 );
    rejection->setMargin( 10 );
    rejection->setCaption( "Rejection Sampling" );
    rejection->setTextColor( samplingColor );

    metropolis.reset( new MetropolisSamplingButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //metropolis->setX( 255 );
    metropolis->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    metropolis->setY( rejection->y() + 20 );
    metropolis->setMargin( 10 );
    metropolis->setCaption( "Metropolis Sampling" );
    metropolis->setTextColor( samplingColor );

    samplingGroup->add( uniform.get() );
    samplingGroup->add( rejection.get() );
    samplingGroup->add( metropolis.get() );
    samplingGroup->show();

    showHide.reset( new ShowHideButton( screen, command ) );
    showHide->setX( metropolis->x() );
    showHide->setY( stop->y() );
    showHide->setWidth( 250 );
    showHide->setCaption( "Show/Hide" );
    showHide->setMargin( 10 );
    showHide->setButtonColor( ::Gray );
    showHide->setTextColor( kvs::RGBColor( 255, 255, 255 ) );

// DELETE START fp)m.tanaka 2013.09.01
    //showHide->show();
// DELETE END   fp)m.tanaka 2013.09.01

    nodeGroup.reset( new kvs::glut::RadioButtonGroup() );

    kvs::RGBColor nodeColor( 255, 122, 255 );

    allnodes.reset( new AllNodesButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //allnodes->setX( metropolis->x() );
    allnodes->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    allnodes->setY( metropolis->y() + 20 );
    allnodes->setMargin( 10 );
    allnodes->setCaption( "All Nodes" );
    allnodes->setTextColor( nodeColor );

    slavenodes.reset( new SlaveNodesButton( screen, command ) );
// MODIFIED START fp)m.tanaka 2013.09.01
    //slavenodes->setX( allnodes->x() );
    slavenodes->setX( rd_offset_x );
// MODIFIED END   fp)m.tanaka 2013.09.01
    slavenodes->setY( allnodes->y() + 20 );
    slavenodes->setMargin( 10 );
    slavenodes->setCaption( "Slave Nodes" );
    slavenodes->setTextColor( nodeColor );

    nodeGroup->add( allnodes.get() );
    nodeGroup->add( slavenodes.get() );
//	nodeGroup->show(); /* removed 2014.07.20 */

    renderingGroup.reset( new kvs::glut::RadioButtonGroup() );

    misesRenderingButton.reset( new MisesRenderingButton( screen, command ) );
    misesRenderingButton->setX( 250 );
    misesRenderingButton->setY( 0 );
    misesRenderingButton->setCaption( "Mises Stress" );
    misesRenderingButton->setMargin( 10 );

    uxRenderingButton.reset( new UXRenderingButton( screen, command ) );
    uxRenderingButton->setX( 250 );
    uxRenderingButton->setY( 20 );
    uxRenderingButton->setCaption( "Ux" );
    uxRenderingButton->setMargin( 10 );

    uyRenderingButton.reset( new UYRenderingButton( screen, command ) );
    uyRenderingButton->setX( 250 );
    uyRenderingButton->setY( 40 );
    uyRenderingButton->setCaption( "Uy" );
    uyRenderingButton->setMargin( 10 );

    uzRenderingButton.reset( new UZRenderingButton( screen, command ) );
    uzRenderingButton->setX( 250 );
    uzRenderingButton->setY( 60 );
    uzRenderingButton->setCaption( "Uz" );
    uzRenderingButton->setMargin( 10 );

    renderingGroup->add( misesRenderingButton.get() );
    renderingGroup->add( uxRenderingButton.get() );
    renderingGroup->add( uyRenderingButton.get() );
    renderingGroup->add( uzRenderingButton.get() );

    // DELETE START fp)m.tanaka 2013.09.01
    //renderingGroup->show();
    // DELETE END   fp)m.tanaka 2013.09.01
};
