/*****************************************************************************/
/**
 *  @file   TFE_Color_1.h
 *  @author Naohisa Sakamoto
 */
/*----------------------------------------------------------------------------
 *
 *  Copyright (c) Visualization Laboratory, Kyoto University.
 *  All rights reserved.
 *  See http://www.viz.media.kyoto-u.ac.jp/kvs/copyright/ for details.
 *
 *  $Id: TFE_Color_1.h 634 2010-10-13 07:04:05Z naohisa.sakamoto $
 */
/*****************************************************************************/
#ifndef KVS__GLUT__LGEND_DIVISION_COLOR_H_INCLUDE
#define KVS__GLUT__LGEND_DIVISION_COLOR_H_INCLUDE

#include <string>
#include <kvs/ClassName>
#include <kvs/OpenGL>
#include <kvs/RGBColor>
#include <kvs/RGBAColor>
#include <kvs/Vector2>
#include <kvs/TransferFunction>
#include <kvs/Texture1D>
#include <kvs/Texture2D>
#include <kvs/MouseReleaseEventListener>
#include <kvs/glut/Screen>
#include <kvs/glut/PushButton>
#include <kvs/glut/Text>
#include <kvs/glut/ColorPalette>

namespace kvs
{

namespace visclient
{
class LegendpanelUI;

/*===========================================================================*/
/**
 *  @brief  Legend Frame Color class.
 */
/*===========================================================================*/
class Legend_Division_Color : public kvs::glut::Screen
{
    kvsClassName( kvs::visclient::Legend_Division_Color );

public:

    typedef kvs::glut::Screen SuperClass;

protected:

    bool m_visible;

    kvs::ScreenBase*              m_screen;              ///< pointer to screen
    kvs::glut::ColorPalette*      m_color_palette;       ///< color palette
    kvs::glut::PushButton*        m_save_button;         ///< save button
    kvs::glut::PushButton*        m_cancel_button;       ///< cancel button

    kvs::visclient::LegendpanelUI* m_parent;

public:

    Legend_Division_Color( kvs::visclient::LegendpanelUI* parent = 0, kvs::ScreenBase* parent_screen = 0 );

    virtual ~Legend_Division_Color( void );

public:

    int show( void );

    virtual void hide( void );

public:

    kvs::ScreenBase* screen( void );

    const kvs::glut::ColorPalette* colorPalette( void ) const;

public:

    const kvs::RGBColor color( void ) const;

public:

    virtual void save( void );

    virtual void cancel( void );
};


} // end of namespace visclient

} // end of namespace kvs

#endif // KVS__GLUT__LGEND_DIVISION_COLOR_H_INCLUDE
