#ifndef __KVS_VISCLIENT_PBVR_RESULT_H__
#define __KVS_VISCLIENT_PBVR_RESULT_H__

#include "VariableRange.h"
#include "FrequencyTable.h"
#include <vector>

namespace kvs
{
namespace visclient
{

class PBVRResult
{
public:
    VariableRange varRange;
    size_t maxMergedTimeStep;
    size_t minMergedTimeStep;
    float maxObjectCoord[3];
    float minObjectCoord[3];

    std::vector<kvs::visclient::FrequencyTable> c_bins, o_bins;
    int32_t subPixelLevel;
    bool isUnderAnimation;

    int32_t minServerTimeStep;
    int32_t maxServerTimeStep;
    int32_t serverTimeStep;

public:
    const kvs::visclient::FrequencyTable* findColorFrequencyTable(const std::string &name)
    {
        std::vector<kvs::visclient::FrequencyTable>::const_iterator itr;
        for (itr=c_bins.begin(); itr!=c_bins.end(); itr++) {
            const kvs::visclient::FrequencyTable *table = &(*itr);
            if (table->m_function_name == name) {
                return table;
            }
        }

        return NULL;
    }

    const kvs::visclient::FrequencyTable* findOpacityFrequencyTable(const std::string &name)
    {
        std::vector<kvs::visclient::FrequencyTable>::const_iterator itr;
        for (itr=o_bins.begin(); itr!=o_bins.end(); itr++) {
            const kvs::visclient::FrequencyTable *table = &(*itr);
            if (table->m_function_name == name) {
                return table;
            }
        }

        return NULL;
    }

};

}
}

#endif

