#ifndef  __PARAM_INFO_H__
#define __PARAM_INFO_H__

#include <string>

#define MAX_TF_NUMBER		99

class ParamInfo
{

private:
    size_t subpixel_level;
    size_t repeat_level;
    float crop_region[6];
    std::map<std::string, bool> param_state;
    std::map<std::string, std::string> param;

public:
    bool get_state( std::string key )
    {
        return ( param_state[key] );
    };

    float get_crop_region( int index );
    size_t get_subpixel_level();
    size_t get_repeat_level();

    int         getInt( std::string name );
    float       getFloat( std::string name );
    std::string getString( std::string name );
    int getTfnameSize();
    std::string getTfnamePrefix(int index);
    int getTfnameNumber(int index);
    bool        hasParam( const std::string& name );

public:
    bool   LoadIN( const std::string& filename );

private:
    bool isTfnameNvalc(const std::string& item);
};

#endif // __PARAM_INFO_H__

