#ifndef __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_H__
#define __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_H__

#include <string>
#include <vector>
#include <kvs/PointObject>
#include "ParticleMergeParam.h"

namespace kvs
{
namespace visclient
{

class ParticleMerger
{

protected:

    ParticleMergeParam m_param;
    ParticleMergeParam m_lastparam;

    std::vector<size_t> m_initial_step;
    std::vector<size_t> m_final_step;
    std::vector<size_t> m_div;
    std::vector<std::string> m_fileprefix;
    float xmin, ymin, zmin;
    float xmax, ymax, zmax;

public:

    ParticleMerger();
    virtual ~ParticleMerger();

    void setParam( const ParticleMergeParam& param, const size_t server_init_step, const size_t server_fin_step );
    bool CalcExternalCoords( float* crd );
    size_t getMergedInitialTimeStep();
    size_t getMergedFinalTimeStep();
    kvs::PointObject* doMerge(
        const kvs::PointObject* server_particle,
        const size_t step );
    void setenable( int i );

};

} // namespace visclient
} // namespace kvs

#endif // __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_H__

